library ieee;
use ieee.std_logic_1164.all;

package uart_pkg is
	component uart_send
		generic(
			TCQ            : time    := 2 ns;
			DATA_WIDTH     : natural := 32;
			BIT_CLOCK_TIME : natural := 4
		);
		port(
			clk_in     : in  std_logic;
			reset_in   : in  std_logic;
			cs_in      : in  std_logic;
			a0_in      : in  std_logic;
			wr_in      : in  std_logic;
			rd_in      : in  std_logic;
			data_in    : in  std_logic_vector(DATA_WIDTH - 1 downto 0);
			data_out   : out std_logic_vector(DATA_WIDTH - 1 downto 0);
			serial_out : out std_logic
		);
	end component uart_send;

	component uart_receive
		generic(
			TCQ            : time    := 2 ns;
			DATA_WIDTH     : natural := 32;
			BIT_CLOCK_TIME : natural := 4
		);
		port(
			clk_in    : in  std_logic;
			reset_in  : in  std_logic;
			cs_in     : in  std_logic;
			a0_in     : in  std_logic;
			wr_in     : in  std_logic;
			rd_in     : in  std_logic;
			data_in   : in  std_logic_vector(DATA_WIDTH - 1 downto 0);
			data_out  : out std_logic_vector(DATA_WIDTH - 1 downto 0);
			serial_in : in  std_logic
		);
	end component uart_receive;

	

end package uart_pkg;